%define __pamdir %_sysconfdir/pam.d
%define __secdir %_sysconfdir/security

Name: pam_bioapi
Version: 0.2.1
Release: alt1
Packager: Yurix <yurix@altlinux.ru>

Summary: A Pluggable Authentication Modules for biometric devices
Summary(ru_RU.UTF-8): Подключаемый модуль аутентификации для биометрических устройств
License: GPL
Group: System/Base
Url: http://www.qrivy.net/~michael/blua/pam_bioapi/

Source0: http://www.qrivy.net/~michael/blua/pam_bioapi/%name-%version.tar.bz2
Patch0: http://badcode.de/downloads/fingerprint.patch

BuildPrereq: bioapi-devel, libpam-devel

# Automatically added by buildreq on Thu Nov 24 2005
BuildRequires: bioapi-devel gcc-c++ libpam-devel libstdc++-devel

%set_pam_name %name

%package -n %pam_name
Summary: A Pluggable Authentication Modules for biometric devices
Summary(ru_RU.UTF-8): Подключаемый модуль аутентификации для биометрических устройств
License: GPL
Group: System/Base
Provides: %name = %version-%release
Obsoletes: %name

%description 
Provides a PAM-compliant interface to use in biometrically
authenticating local users

Install %name if you want to implement biometric authentication.

%description -l ru_RU.UTF-8
%name это подключаемый модуль аутентификации Linux-PAM для
биометрических устройств, посредством библиотек BioAPI.

Установите %name если собираетесь внедрять аутентификацию
по биометрическим показателям.

%description -n %pam_name
Provides a PAM-compliant interface to use in biometrically
authenticating local users

Install %name if you want to implement biometric authentication.

%description -n %pam_name -l ru_RU.UTF-8
%name это подключаемый модуль аутентификации Linux-PAM для
биометрических устройств, посредством библиотек BioAPI.

Установите %name если собираетесь внедрять аутентификацию
по биометрическим показателям.

%prep
%setup -q -n %name-%version
%patch -p0
%__subst ":/etc/bioapi1.10/pam/:%__secdir/bioapi/:" README

echo '#!/bin/sh
SERIAL=$(%_bindir/BioAPITest | sed -ne \
 "/Fingerprint/{n;n;s/^.*: \(.\{9\}\)\(.\{4\}\)\(.\{4\}\)\(.\{4\}\)\(.*\)/\1-\2-\3-\4-\5/gp}")
[ "$(echo "$SERIAL"|wc -c)" == "39" ] || {
    echo "Sorry. Can not find Fingerprint Reader"
    exit 1
    }
echo "Found Fingerprint Reader with serial: $SERIAL"
echo "You should use following directory to store your <username>.bir files:"
echo "	%__secdir/bioapi/$SERIAL"
[ -d %__secdir/bioapi/$SERIAL ] || %__mkdir %__secdir/bioapi/$SERIAL

%__sed -e "s/-=SERIAL=-/$SERIAL/g" %__secdir/bioapi/fingerprint-auth-template \
 >%__pamdir/fingerprint-auth

echo "You can add fingerprint authentication to selected"
echo "services by adding following lines to the stack"
echo "in %__pamdir/some-service file:"
echo
echo "    auth     include        fingerprint-auth"
echo " above <auth ... system-auth> line"
echo "    password include        fingerprint-auth"
echo " above <password ... system-auth> line"
echo 
echo "su,xdm,and even login are good candidates"
echo "And do not forget to make <username>.bir files"
echo "for your users using QSample or Sample tools"
echo
    
exit 0
' > find_upec_fpr_serial.sh

echo '#
# Please do not edit this file.
# It could be overwritten by find_upec_fpr_serial.sh script
#
auth     sufficient     pam_bioapi.so -=SERIAL=- %__secdir/bioapi/
password sufficient     pam_bioapi.so -=SERIAL=- %__secdir/bioapi/
' > fingerprint-auth-template

echo 'To start using UPEC Fingerprint Reader found on some laptops
e.g IBM Thinkpad you will need to download closed-source driver
(TFMESS_BSP_LIN_1.0beta2.zip) from ftp://linux:Tuc-nak3@delta.upek.com

 # unzip TFMESS_BSP_LIN_1.0beta2.zip
 # cp libtfmessbsp.so /usr/lib
 # mod_install -fi /usr/lib/libtfmessbsp.so

After that run as root

 # find_upec_fpr_serial.sh

Have fun with your TouchChip TFM/ESS Fingerprint Reader' > README-UPEC-FingerPrintReader-alt.txt

%build
%add_optflags %optflags_shared
%configure --libdir=/%_lib
%make_build
# CFLAGS="$RPM_OPT_FLAGS -Werror -W"

%install
%make_install install DESTDIR=%buildroot SECUREDIR=%_pam_modules_dir
%add_findprov_lib_path %_pam_modules_dir
%__mkdir_p %buildroot%__secdir/bioapi
%__install -m 0700 find_upec_fpr_serial.sh %buildroot%_bindir
%__install -m 0600 fingerprint-auth-template %buildroot%__secdir/bioapi
rm -f	%buildroot%_pam_modules_dir/*.la

%files
%_pam_modules_dir/*
%_bindir/*
%dir %__secdir/bioapi
%__secdir/bioapi/*
%doc README COPYING AUTHORS NEWS ChangeLog README-UPEC-FingerPrintReader-alt.txt

%changelog
* Thu Nov 24 2005 Yury Konovalov <yurix@altlinux.ru> 0.2.1-alt1
- Initial build
